From 19d825bf7373ec67da438f6ca21bdde9a28496d7 Mon Sep 17 00:00:00 2001
From: Michael Neumann <mneumann@ntecs.de>
Date: Thu, 7 Aug 2025 12:44:18 +0200
Subject: [PATCH 2/2] opencrypto - remove in-kernel crypto(9) framework

The opencrypto crypto(9) API was too complex (8k LoC) and unused
as of now.  It allowed for chaining various operations, crypto ops and
compression, but AFAIK this was never really used. For a much simpler,
synchronous API see sys/src/crypto/cryptoapi.

The opencrypto API was asynchronous by design. This was good back in the
days when dedicated hardware crypto devices did exist to help offload the
CPU. But the world has now changed towards synchronous CPU instructions
like AESNI. These dedicated CPU instructions are best called
synchronously, which removes the need for book-keeping of asynchronous
requests, often greatly simplifying the caller as well as the API and
"backend" implementation.

There is also no need to call those CPU instructions in-kernel, so
applications like OpenSSL can simply make use of them regardless of the
operating system.  This further avoids context switches going from
userland to kernel and vice versa.

For a much simpler and synchronous crypto API that both works in-kernel
as well as in userland (without the need to go through /dev/crypto
device), see src/sys/crypto/cryptoapi.
---
 Makefile_upgrade.inc          |   20 +
 include/Makefile              |    4 -
 lib/libtcplay/crypto-dev.c    |  165 ----
 share/man/man4/Makefile       |    1 -
 share/man/man4/aesni.4        |   95 --
 share/man/man4/rndtest.4      |    4 +-
 share/man/man9/Makefile       |   18 -
 share/man/man9/crypto.9       |  672 --------------
 sys/conf/files                |   10 +-
 sys/conf/kmod.mk              |    2 +-
 sys/crypto/Makefile           |    7 +-
 sys/crypto/aesni/aesni.h      |    7 +-
 sys/crypto/crypto.c           |   45 +
 sys/dev/crypto/Makefile       |    2 +-
 sys/dev/crypto/aesni/Makefile |    7 -
 sys/dev/crypto/aesni/aesni.c  |  516 -----------
 sys/dev/crypto/aesni/aesni.h  |   70 --
 sys/opencrypto/cast.c         |  242 -----
 sys/opencrypto/cast.h         |   23 -
 sys/opencrypto/castsb.h       |  545 -----------
 sys/opencrypto/criov.c        |  197 ----
 sys/opencrypto/crypto.c       | 1651 ---------------------------------
 sys/opencrypto/cryptodev.h    |  462 ---------
 sys/opencrypto/cryptodev_if.m |   55 --
 sys/opencrypto/cryptosoft.c   | 1433 ----------------------------
 sys/opencrypto/cryptosoft.h   |   69 --
 sys/opencrypto/deflate.c      |  174 ----
 sys/opencrypto/deflate.h      |   56 --
 sys/opencrypto/gmac.c         |  159 ----
 sys/opencrypto/gmac.h         |   51 -
 sys/opencrypto/skipjack.c     |  258 ------
 sys/opencrypto/skipjack.h     |   19 -
 sys/opencrypto/xform.c        | 1099 ----------------------
 sys/opencrypto/xform.h        |  119 ---
 sys/platform/pc64/conf/files  |    1 -
 35 files changed, 73 insertions(+), 8185 deletions(-)
 delete mode 100644 lib/libtcplay/crypto-dev.c
 delete mode 100644 share/man/man4/aesni.4
 delete mode 100644 share/man/man9/crypto.9
 create mode 100644 sys/crypto/crypto.c
 delete mode 100644 sys/dev/crypto/aesni/Makefile
 delete mode 100644 sys/dev/crypto/aesni/aesni.c
 delete mode 100644 sys/dev/crypto/aesni/aesni.h
 delete mode 100644 sys/opencrypto/cast.c
 delete mode 100644 sys/opencrypto/cast.h
 delete mode 100644 sys/opencrypto/castsb.h
 delete mode 100644 sys/opencrypto/criov.c
 delete mode 100644 sys/opencrypto/crypto.c
 delete mode 100644 sys/opencrypto/cryptodev.h
 delete mode 100644 sys/opencrypto/cryptodev_if.m
 delete mode 100644 sys/opencrypto/cryptosoft.c
 delete mode 100644 sys/opencrypto/cryptosoft.h
 delete mode 100644 sys/opencrypto/deflate.c
 delete mode 100644 sys/opencrypto/deflate.h
 delete mode 100644 sys/opencrypto/gmac.c
 delete mode 100644 sys/opencrypto/gmac.h
 delete mode 100644 sys/opencrypto/skipjack.c
 delete mode 100644 sys/opencrypto/skipjack.h
 delete mode 100644 sys/opencrypto/xform.c
 delete mode 100644 sys/opencrypto/xform.h

diff --git a/Makefile_upgrade.inc b/Makefile_upgrade.inc
index 2f61890fc2..4d79139830 100644
--- a/Makefile_upgrade.inc
+++ b/Makefile_upgrade.inc
@@ -3937,6 +3937,26 @@ TO_REMOVE+=/usr/share/man/man4/safe.4.gz
 TO_REMOVE+=/usr/share/man/man4/ubsec.4.gz
 TO_REMOVE+=/usr/share/man/man4/crypto.4.gz
 TO_REMOVE+=/usr/share/man/man4/cryptodev.4.gz
+TO_REMOVE+=/usr/share/man/man9/crypto.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_dispatch.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_done.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_find_device_byhid.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_find_driver.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_freereq.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_freesession.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_get_driverid.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_getcaps.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_getreq.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_kdispatch.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_kdone.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_kregister.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_newsession.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_register.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_unblock.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_unregister_all.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_unregister.9.gz
+TO_REMOVE+=/usr/share/man/man9/aesni.4.gz
+
  
 .if !defined(WANT_INSTALLER)
 TO_REMOVE+=/usr/sbin/dfuibe_installer
diff --git a/include/Makefile b/include/Makefile
index cad9e329cc..3de581b3d7 100644
--- a/include/Makefile
+++ b/include/Makefile
@@ -168,8 +168,6 @@ copies:		mtree_setup
 		${INSTALL} -C -o ${BINOWN} -g ${BINGRP} -m 444 crypto/rijndael/rijndael.h \
 		${DESTDIR}/usr/include/crypto; \
 		${INSTALL} -C -o ${BINOWN} -g ${BINGRP} -m 444 crypto/rmd160/rmd160.h \
-		${DESTDIR}/usr/include/crypto; \
-		${INSTALL} -C -o ${BINOWN} -g ${BINGRP} -m 444 opencrypto/*.h \
 		${DESTDIR}/usr/include/crypto
 	cd ${.CURDIR}/../sys/dev/acpica; \
 		${INSTALL} -C -o ${BINOWN} -g ${BINGRP} -m 444 acpiio.h \
@@ -238,8 +236,6 @@ symlinks:	mtree_setup
 	rm -rf ${DESTDIR}/usr/include/$i
 	${LN} -s ../../sys/$i ${DESTDIR}/usr/include/$i
 .endfor
-	rm -rf ${DESTDIR}/usr/include/crypto
-	${LN} -s ../../sys/opencrypto ${DESTDIR}/usr/include/crypto
 .for i in ${LSYMSUBDIRS}
 	rm -rf ${DESTDIR}/usr/include/$i
 	${LN} -s ${i:C;[^/]+/?;../;g}../sys/$i ${DESTDIR}/usr/include/$i
diff --git a/share/man/man4/Makefile b/share/man/man4/Makefile
index 71494b900b..e15375db80 100644
--- a/share/man/man4/Makefile
+++ b/share/man/man4/Makefile
@@ -18,7 +18,6 @@ MAN=	aac.4 \
 	adv.4 \
 	adw.4 \
 	ae.4 \
-	aesni.4 \
 	age.4 \
 	agp.4 \
 	ahci.4 \
diff --git a/share/man/man9/Makefile b/share/man/man9/Makefile
index 13d65b234b..ef81ff1a4e 100644
--- a/share/man/man9/Makefile
+++ b/share/man/man9/Makefile
@@ -37,7 +37,6 @@ MAN=	accept_filter.9 \
 	copy.9 \
 	CPUMASK.9 \
 	crit_enter.9 \
-	crypto.9 \
 	DB_COMMAND.9 \
 	DECLARE_MODULE.9 \
 	DELAY.9 \
@@ -445,23 +444,6 @@ MLINKS+=crit_enter.9 crit_enter_gd.9 \
 	crit_enter.9 crit_exit.9 \
 	crit_enter.9 crit_exit_gd.9 \
 	crit_enter.9 crit_exit_id.9
-MLINKS+=crypto.9 crypto_dispatch.9 \
-	crypto.9 crypto_done.9 \
-	crypto.9 crypto_find_device_byhid.9 \
-	crypto.9 crypto_find_driver.9 \
-	crypto.9 crypto_freereq.9 \
-	crypto.9 crypto_freesession.9 \
-	crypto.9 crypto_getcaps.9 \
-	crypto.9 crypto_get_driverid.9 \
-	crypto.9 crypto_getreq.9 \
-	crypto.9 crypto_kdispatch.9 \
-	crypto.9 crypto_kdone.9 \
-	crypto.9 crypto_kregister.9 \
-	crypto.9 crypto_newsession.9 \
-	crypto.9 crypto_register.9 \
-	crypto.9 crypto_unblock.9 \
-	crypto.9 crypto_unregister.9 \
-	crypto.9 crypto_unregister_all.9
 MLINKS+=DB_COMMAND.9 DB_COMMAND_FLAG.9 \
 	DB_COMMAND.9 DB_SHOW_COMMAND.9
 MLINKS+=devclass_add_driver.9 devclass_delete_driver.9 \
diff --git a/sys/conf/files b/sys/conf/files
index b7128631a9..130bd5094f 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -2250,6 +2250,7 @@ crypto/camellia/camellia.c		optional crypto
 crypto/camellia/camellia-api.c		optional crypto
 crypto/chacha20/chacha.c		optional crypto
 crypto/chachapoly.c			optional crypto
+crypto/crypto.c				optional crypto
 crypto/cryptoapi/cryptoapi.c		optional crypto
 crypto/curve25519/curve25519.c		optional crypto
 crypto/des/des_ecb.c			optional crypto
@@ -2266,15 +2267,6 @@ crypto/sha2/sha2.c			standard
 crypto/siphash/siphash.c		optional crypto
 crypto/twofish/twofish.c		optional crypto
 net/zlib.c				optional crypto
-opencrypto/cast.c			optional crypto
-opencrypto/criov.c			optional crypto
-opencrypto/crypto.c			optional crypto
-opencrypto/cryptodev_if.m		optional crypto
-opencrypto/cryptosoft.c			optional crypto
-opencrypto/deflate.c			optional crypto
-opencrypto/gmac.c			optional crypto
-opencrypto/skipjack.c			optional crypto
-opencrypto/xform.c			optional crypto
 # drm_agpsupport.c must be included if CONFIG_AGP is set
 #dev/drm/drm_agpsupport.c		optional drm compile-with "${NORMAL_C} -include $S/dev/drm/kconfig.h ${WERROR}"
 dev/drm/drm_atomic.c			optional drm compile-with "${NORMAL_C} -include $S/dev/drm/kconfig.h ${WERROR}"
diff --git a/sys/conf/kmod.mk b/sys/conf/kmod.mk
index 764df1c766..3ffae6dce0 100644
--- a/sys/conf/kmod.mk
+++ b/sys/conf/kmod.mk
@@ -350,7 +350,7 @@ MFILES?= kern/bus_if.m kern/device_if.m bus/iicbus/iicbb_if.m \
     dev/sound/pcm/feeder_if.m dev/sound/pcm/mixer_if.m \
     dev/sound/midi/mpu_if.m dev/sound/midi/mpufoi_if.m \
     dev/sound/midi/synth_if.m  \
-    libiconv/iconv_converter_if.m dev/agp/agp_if.m opencrypto/cryptodev_if.m \
+    libiconv/iconv_converter_if.m dev/agp/agp_if.m \
     bus/mmc/mmcbus_if.m bus/mmc/mmcbr_if.m \
     dev/virtual/virtio/virtio/virtio_bus_if.m \
     dev/misc/backlight/backlight_if.m dev/misc/coremctl/coremctl_if.m kern/cpu_if.m \
diff --git a/sys/crypto/Makefile b/sys/crypto/Makefile
index 1fbae90945..a241d8b32a 100644
--- a/sys/crypto/Makefile
+++ b/sys/crypto/Makefile
@@ -2,10 +2,7 @@
 
 KMOD=	crypto
 
-.PATH:	${.CURDIR}/../opencrypto
-SRCS=	cast.c criov.c crypto.c cryptosoft.c deflate.c gmac.c \
-	skipjack.c xform.c
-SRCS+=	cryptodev_if.c cryptodev_if.h
+SRCS=	crypto.c
 
 SRCS+=	sha1.c
 SRCS+=	chachapoly.c
@@ -55,8 +52,6 @@ SRCS+=	twofish.c
 .PATH:	${.CURDIR}/cryptoapi
 SRCS+=	cryptoapi.c
 
-SRCS+=	bus_if.h device_if.h opt_ddb.h
-
 SUBDIR=	rc4
 
 .include <bsd.kmod.mk>
diff --git a/sys/crypto/aesni/aesni.h b/sys/crypto/aesni/aesni.h
index f3dab54d46..327adfb0cc 100644
--- a/sys/crypto/aesni/aesni.h
+++ b/sys/crypto/aesni/aesni.h
@@ -32,10 +32,9 @@
 #include <sys/types.h>
 #include <sys/_null.h>
 
-/**
- * AES_BLOCK_LEN is also defined in opencrypto/cryptodev.h
- */
-#ifndef AES_BLOCK_LEN
+#ifdef AES_BLOCK_LEN
+#error "AES_BLOCK_LEN already defined!"
+#else
 #define AES_BLOCK_LEN	16
 #endif
 
diff --git a/sys/crypto/crypto.c b/sys/crypto/crypto.c
new file mode 100644
index 0000000000..8ef1d5635d
--- /dev/null
+++ b/sys/crypto/crypto.c
@@ -0,0 +1,45 @@
+/*-
+ * Copyright (c) 2025 Michael Neumann.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/module.h>
+
+int crypto_modevent(module_t mod, int type, void *unused);
+
+int
+crypto_modevent(module_t mod __unused, int type, void *unused __unused)
+{
+	switch (type) {
+	case MOD_LOAD:
+		if (bootverbose)
+			kprintf("crypto: loaded\n");
+		return 0;
+	case MOD_UNLOAD:
+		return 0;
+	default:
+		return EINVAL;
+	}
+}
+MODULE_VERSION(crypto, 1);
diff --git a/sys/dev/crypto/Makefile b/sys/dev/crypto/Makefile
index 54f9b1cab0..e6a6d452a8 100644
--- a/sys/dev/crypto/Makefile
+++ b/sys/dev/crypto/Makefile
@@ -1,4 +1,4 @@
-SUBDIR=	aesni rdrand rndtest tpm
+SUBDIR=	rdrand rndtest tpm
 
 # Empty for concurrent build
 #
diff --git a/sys/platform/pc64/conf/files b/sys/platform/pc64/conf/files
index fe4f71bc02..9062fa76b5 100644
--- a/sys/platform/pc64/conf/files
+++ b/sys/platform/pc64/conf/files
@@ -65,7 +65,6 @@ ${OSACPI_MD_DIR}/acpi_wakeup.c		optional        acpi
 crypto/aesni/aesencdec_x86_64.S		optional	aesni
 crypto/aesni/aeskeys_x86_64.S		optional	aesni
 crypto/aesni/aesni_wrap.c		optional	aesni
-dev/crypto/aesni/aesni.c		optional	aesni
 dev/crypto/rdrand/rdrand.c		optional	rdrand
 dev/crypto/rdrand/rdrand_harvest_x86_64.S	optional	rdrand
 dev/video/fb/fb.c			optional	vga
-- 
2.45.2

